// By Sven Thommesen <sthomme@humsci.auburn.edu>
// "HumbugModelSwarm.m"

// Import Swarm libraries:

#import <math.h>
#import <space.h>
#import <activity.h>
#import <collections.h>
#import <objectbase.h>
#import <simtools.h>
#import <random.h>

#import "HumbugModelSwarm.h"

// HumbugModelSwarm.m.8:
// Simple informational output for each object 
// Usage: './humbug -b > runlog'


@implementation HumbugModelSwarm

+createBegin: (id) aZone {
  HumbugModelSwarm * obj;

  obj = [super createBegin: aZone];

  obj->debugPrint = 1;

  obj->myStream = [ OutputStream create: aZone setFileStream: stdout ];

  return obj;
}

-createEnd {
  return [super createEnd];
}

-buildObjects {
  unsigned int mySeeds[1024];
  int i,j;
  id myGen1, myGen2, myGen3, myGen4, myGen5;
 
  [super buildObjects];

  // printf(" Create generators: \n");

  mySeeds[0] = DEFAULTSEED1;
  mySeeds[1] = DEFAULTSEED2;
  mySeeds[2] = DEFAULTSEED3;
  mySeeds[3] = DEFAULTSEED4;

  printf("DEFAULTSEED  = %12u\n", DEFAULTSEED);
  printf("DEFAULTSEED1 = %12u\n", DEFAULTSEED1);
  printf("DEFAULTSEED2 = %12u\n", DEFAULTSEED2);
  printf("DEFAULTSEED3 = %12u\n", DEFAULTSEED3);
  printf("DEFAULTSEED4 = %12u\n", DEFAULTSEED4);
  printf("\n");

  printf("useFixedSeed = %12d\n", _useFixedSeed);
  printf("firstSeed    = %12u\n", _firstSeed);
  printf("\n");

  printf("Clocks per sec = %d so clock step = %d microseconds\n\n", 
     CLOCKS_PER_SEC, 1000000 / CLOCKS_PER_SEC);

  printf("getpid = %d\n\n", getpid());

  printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
  printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
  printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
  printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
  printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
  printf("\n");

printf("tempusFugit = %12u\n", tempusFugit());
printf("tempusFugit = %12u\n", tempusFugit());
printf("tempusFugit = %12u\n", tempusFugit());
printf("tempusFugit = %12u\n", tempusFugit());
printf("tempusFugit = %12u\n", tempusFugit());
printf("\n");

i = sleep(1);
printf("sleep+tempusFugit = %12u\n", tempusFugit());
i = sleep(1);
printf("sleep+tempusFugit = %12u\n", tempusFugit());
i = sleep(1);
printf("sleep+tempusFugit = %12u\n", tempusFugit());
i = sleep(1);
printf("sleep+tempusFugit = %12u\n", tempusFugit());
i = sleep(1);
printf("sleep+tempusFugit = %12u\n", tempusFugit());
printf("\n");

printf("time = %12ld\n", time(0));
printf("time = %12ld\n", time(0));
printf("time = %12ld\n", time(0));
printf("time = %12ld\n", time(0));
printf("time = %12ld\n", time(0));
printf("\n");

printf("clock = %12ld\n", clock());
printf("clock = %12ld\n", clock());
printf("clock = %12ld\n", clock());
printf("clock = %12ld\n", clock());
printf("clock = %12ld\n", clock());
printf("\n");

i = sleep(1);
printf("sleep+clock = %12ld\n", clock());
i = sleep(1);
printf("sleep+clock = %12ld\n", clock());
i = sleep(1);
printf("sleep+clock = %12ld\n", clock());
i = sleep(1);
printf("sleep+clock = %12ld\n", clock());
i = sleep(1);
printf("sleep+clock = %12ld\n", clock());
printf("\n");

for (i=0; i<1000; i++) j=i;
printf("delay+clock = %12ld\n", clock());
for (i=0; i<1000; i++) j=i;
printf("delay+clock = %12ld\n", clock());
for (i=0; i<1000; i++) j=i;
printf("delay+clock = %12ld\n", clock());
for (i=0; i<1000; i++) j=i;
printf("delay+clock = %12ld\n", clock());
for (i=0; i<1000; i++) j=i;
printf("delay+clock = %12ld\n", clock());
printf("\n");

printf("CHICKENFEED = %12u\n", CHICKENFEED);
printf("CHICKENFEED = %12u\n", CHICKENFEED);
printf("CHICKENFEED = %12u\n", CHICKENFEED);
printf("CHICKENFEED = %12u\n", CHICKENFEED);
printf("CHICKENFEED = %12u\n", CHICKENFEED);
printf("\n");

printf("BIRDSEED    = %12u\n", BIRDSEED);
printf("BIRDSEED    = %12u\n", BIRDSEED);
printf("BIRDSEED    = %12u\n", BIRDSEED);
printf("BIRDSEED    = %12u\n", BIRDSEED);
printf("BIRDSEED    = %12u\n", BIRDSEED);
printf("\n");

printf("SLEEPYSEED  = %12u\n", SLEEPYSEED);
printf("SLEEPYSEED  = %12u\n", SLEEPYSEED);
printf("SLEEPYSEED  = %12u\n", SLEEPYSEED);
printf("SLEEPYSEED  = %12u\n", SLEEPYSEED);
printf("SLEEPYSEED  = %12u\n", SLEEPYSEED);
printf("\n");

printf("PIDTIMESEED = %12u\n", PIDTIMESEED);
printf("PIDTIMESEED = %12u\n", PIDTIMESEED);
printf("PIDTIMESEED = %12u\n", PIDTIMESEED);
printf("PIDTIMESEED = %12u\n", PIDTIMESEED);
printf("PIDTIMESEED = %12u\n", PIDTIMESEED);
printf("\n");

printf("PIDRANDSEED = %12u\n", PIDRANDSEED);
printf("PIDRANDSEED = %12u\n", PIDRANDSEED);
printf("PIDRANDSEED = %12u\n", PIDRANDSEED);
printf("PIDRANDSEED = %12u\n", PIDRANDSEED);
printf("PIDRANDSEED = %12u\n", PIDRANDSEED);
printf("\n");

printf("FIRSTSEED   = %12u\n", FIRSTSEED);
printf("\n");

printf("NEXTSEED    = %12u\n", NEXTSEED);
printf("NEXTSEED    = %12u\n", NEXTSEED);
printf("NEXTSEED    = %12u\n", NEXTSEED);
printf("NEXTSEED    = %12u\n", NEXTSEED);
printf("NEXTSEED    = %12u\n", NEXTSEED);
printf("\n");

printf("RANDOMSEED  = %12u\n", RANDOMSEED);
printf("RANDOMSEED  = %12u\n", RANDOMSEED);
printf("RANDOMSEED  = %12u\n", RANDOMSEED);
printf("RANDOMSEED  = %12u\n", RANDOMSEED);
printf("RANDOMSEED  = %12u\n", RANDOMSEED);
printf("\n");


printf("STARTSEED   = %12u\n", STARTSEED);
printf("STARTSEED   = %12u\n", STARTSEED);
printf("STARTSEED   = %12u\n", STARTSEED);
printf("STARTSEED   = %12u\n", STARTSEED);
printf("STARTSEED   = %12u\n", STARTSEED);
printf("\n");

printf("Creating new generators:\n\n");
myGen1 = [PMMLCG1gen createWithDefaults: [self getZone]];
printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
myGen2 = [PMMLCG1gen createWithDefaults: [self getZone]];
printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
myGen3 = [PMMLCG1gen createWithDefaults: [self getZone]];
printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
myGen4 = [PMMLCG1gen createWithDefaults: [self getZone]];
printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
myGen5 = [PMMLCG1gen createWithDefaults: [self getZone]];
printf("time = %ld   clock = %ld   tempusFugit = %u\n", 
	time(0), clock(), tempusFugit()  );
printf("\n");

  [myGen1 drop];
  [myGen2 drop];
  [myGen3 drop];
  [myGen4 drop];
  [myGen5 drop];

printf("\n");

  return self;
}

-buildActions {

  [super buildActions];

  return self;
}

-activateIn: (id) swarmContext {

  [super activateIn: swarmContext];

  return [self getSwarmActivity];
}

@end
