// By Sven Thommesen <sthomme@humsci.auburn.edu>
// "HumbugModelSwarm.h"

// Import Swarm libraries:

#import <space.h>
#import <activity.h>
#import <collections.h>
#import <objectbase.h>

#import <random.h>
#import <objectbase/Swarm.h>

@interface HumbugModelSwarm: Swarm
{
  int debugPrint;

// Internal data objects:

  id <SimpleRandomGenerator>   pmmlcg1Generator;
  id <SimpleRandomGenerator>   pmmlcg2Generator;
  id <SimpleRandomGenerator>   pmmlcg3Generator;
  id <SimpleRandomGenerator>   pmmlcg4Generator;
  id <SimpleRandomGenerator>   pmmlcg5Generator;
  id <SimpleRandomGenerator>   pmmlcg6Generator;
  id <SimpleRandomGenerator>   pmmlcg7Generator;
  id <SimpleRandomGenerator>   pmmlcg8Generator;
  id <SimpleRandomGenerator>   pmmlcg9Generator;
  id <SimpleRandomGenerator>      lcg1Generator;
  id <SimpleRandomGenerator>      lcg2Generator;
  id <SimpleRandomGenerator>      lcg3Generator;
  id <SimpleRandomGenerator>       acgGenerator;
  id <SimpleRandomGenerator>       scgGenerator;
  id <SimpleRandomGenerator>      swb1Generator;
  id <SimpleRandomGenerator>      swb2Generator;
  id <SimpleRandomGenerator>      swb3Generator;
  id <SimpleRandomGenerator>      pswbGenerator;
  id <SimpleRandomGenerator>     TT403Generator;
  id <SimpleRandomGenerator>     TT775Generator;
  id <SimpleRandomGenerator>     TT800Generator;
  id <SimpleRandomGenerator>   MT19937Generator;
  id <SimpleRandomGenerator>      mrg5Generator;
  id <SimpleRandomGenerator>      mrg6Generator;
  id <SimpleRandomGenerator>      mrg7Generator;
  id <SimpleRandomGenerator>    c2mrg3Generator;
  id <SimpleRandomGenerator>   c2taus1Generator;
  id <SimpleRandomGenerator>   c2taus2Generator;
  id <SimpleRandomGenerator>   c2taus3Generator;
  id <SimpleRandomGenerator>      mwcaGenerator;
  id <SimpleRandomGenerator>      mwcbGenerator;
  id <SimpleRandomGenerator>     c3mwcGenerator;
  id <SimpleRandomGenerator>      rwc2Generator;
  id <SimpleRandomGenerator>      rwc8Generator;

  id <SplitRandomGenerator>    c2lcgxGenerator;
  id <SplitRandomGenerator>    c4lcgxGenerator;

  id <RandomBitDist>       randomBitDist;
  id <BernoulliDist>       bernoulliDist;
  id <UniformIntegerDist>  uniformIntegerDist;
  id <UniformUnsignedDist> uniformUnsignedDist;
  id <UniformDoubleDist>   uniformDoubleDist;
  id <NormalDist>          normalDist;
  id <LogNormalDist>       logNormalDist;
  id <ExponentialDist>     exponentialDist;
  id <GammaDist>           gammaDist;

  id <SimpleRandomGenerator> myGen;
  id <SimpleRandomGenerator> mySimpleGen;
  id <SplitRandomGenerator>  mySplitGen;

// Internal scheduling objects:

  id modelPreActions, modelPostActions;
  id modelPreSchedule, modelPostSchedule;

  id myStream;	// output stream

}

// Create the object:
+createBegin: (id) aZone;
-createEnd;

// Do the usual Swarm things:
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

@end
